package index

import (
	"github.com/gin-gonic/gin"
	"io/ioutil"
	"log"
	"net/http"
	"net/http/cookiejar"
	"regexp"
	"strconv"
	"strings"
	"time"
)

type IndexController struct {
}

func (con IndexController) Main(c *gin.Context) {

	res, _ := Http("https://login.wx.qq.com/jslogin?appid=wx782c26e4c19acffb&redirect_uri=https%3A%2F%2Fweb.weixin.qq.com%2Fcgi-bin%2Fmmwebwx-bin%2Fwebwxnewloginpage&fun=new&lang=zh_&_=" + strconv.FormatInt(time.Now().UnixNano(), 10))

	reg := `window.QRLogin.code = 200; window.QRLogin.uuid = "(.*?)"`
	compile := regexp.MustCompile(reg)
	row := compile.FindStringSubmatch(res)

	c.HTML(http.StatusOK, "index/index/index", gin.H{
		"uuid": row[1],
	})

}

func (con IndexController) Ajax(c *gin.Context) {
	uuid := c.Query("uuid")

	res, _ := Http("https://login.wx.qq.com/cgi-bin/mmwebwx-bin/login?loginicon=true&uuid=" + uuid)
	reg := `window.code=(.*?);(.*?)`
	compile := regexp.MustCompile(reg)
	row := compile.FindAllSubmatch([]byte(res), -1)

	code, content := "", ""
	for _, v := range row {
		code = string(v[1])
		content = string(v[2])
	}

	if code == "200" {
		reg1 := `.*?window.redirect_uri="(.*?)"`
		compile := regexp.MustCompile(reg1)
		row1 := compile.FindStringSubmatch(res)
		_, content = Http(row1[1])
	}

	c.JSON(http.StatusOK, gin.H{
		"code":    code,
		"content": content,
	})
}

func Http(url string) (string, string) {

	cookie, _ := cookiejar.New(nil)

	client := &http.Client{
		Jar: cookie,
	}
	req, err := http.NewRequest("GET", url, strings.NewReader(string("")))
	if err != nil {
		log.Println(err)
	}
	resp, err := client.Do(req)
	resp.Header.Set("Referer", url)

	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		log.Println(err)
	}

	cookies := cookie.Cookies(req.URL)

	log.Println(cookies)

	uin := ""

	for i := 0; i < len(cookies); i++ {
		if cookies[i].Name == "wxuin" {
			uin = cookies[i].Value
		}
	}

	return string(body), uin
}
